<?php
/**
 * Ipay88
 * @author Ipay88
 * @package Ipay88\Lib
 */

class ipay88_CreditCard_Indonesia
{
    const URL_PAYMENT_PRODUCTION 				= 'https://payment.ipay88.co.id/epayment/entry.asp';
    const URL_PAYMENT_SANDBOX    				= 'https://sandbox.ipay88.co.id/epayment/entry.asp';

    const PAYMENT_METHOD_ENABLE 				= "yes";
    const PAYMENT_METHOD_DISABLE				= "no";

	// creditcard	
	const PAYMENT_METHOD_CREDITCARD					= 41;
	const PAYMENT_METHOD_MAYBANK2D					= 47;
	const PAYMENT_METHOD_BRI2D					    = 48;
    const PAYMENT_METHOD_ARTAJASAGPN				= 49;
	const PAYMENT_METHOD_BCAPREAUTH					= 52;
	const PAYMENT_METHOD_UNIONPAY					= 54;
    const PAYMETHOD_ID_3D_BCA = 101;
    const PAYMETHOD_ID_3D_CIMB_MPGS = 103;
    const PAYMETHOD_ID_3D_CIMB_IPG = 87;
    const PAYMETHOD_ID_3D_BRI = 105;
    const PAYMETHOD_ID_3D_DANAMON = 88;
    const PAYMETHOD_ID_3D_MAYBANK = 89;
    const PAYMETHOD_ID_2D_BCA = 102;
    const PAYMETHOD_ID_2D_CIMB = 104;
    const PAYMETHOD_ID_2D_CIMB_IPG = 44;
    const PAYMETHOD_ID_2D_BRI = 106;
    const PAYMETHOD_ID_CIMB_IPG = 34;
	
    const MERCHANT_CODE 						= 'ipay88_merchant_code';
    const MERCHANT_KEY  						= 'ipay88_merchant_key';
    const PAYMENT_MODE  						= 'ipay88_payment_mode';
	
	const PAYMENT_METHOD_CREDITCARD_3D_CONFIG				= 'ipay88_creditcard_3d_config';
	const PAYMENT_METHOD_CREDITCARD_2D_CONFIG				= 'ipay88_creditcard_2d_config';
	const PAYMENT_METHOD_ARTAJASAGPN_CONFIG				= 'ipay88_artajasagpn_config';
	const PAYMENT_METHOD_UNIONPAY_CONFIG				= 'ipay88_unionpay_config';

    const PAYMETHOD_3D_CIMB_CONFIG = 'ipay88_paymethod_3d_cimb';
    const PAYMETHOD_3D_CIMB_MPGS_CONFIG = 'ipay88_paymethod_3d_cimb_mpgs';
    const PAYMETHOD_3D_CIMB_IPG_CONFIG = 'ipay88_paymethod_3d_cimb_ipg';
    const PAYMETHOD_3D_BCA_CONFIG = 'ipay88_paymethod_3d_bca';
    const PAYMETHOD_3D_BRI_CONFIG = 'ipay88_paymethod_3d_bri';
    const PAYMETHOD_3D_DANAMON_CONFIG = 'ipay88_paymethod_3d_danamon';
    const PAYMETHOD_3D_MAYBANK_CONFIG = 'ipay88_paymethod_3d_maybank';
    const PAYMETHOD_CIMB_IPG_CONFIG = 'ipay88_paymethod_cimb_ipg';

    const PAYMETHOD_3D_CIMB_CONFIG_LABEL = 'Credit/Debit Card CIMB';
    const PAYMETHOD_3D_CIMB_MPGS_CONFIG_LABEL = 'Credit/Debit Card CIMB MPGS 3D';
    const PAYMETHOD_3D_CIMB_IPG_CONFIG_LABEL = 'Credit/Debit Card CIMB IPG 3D';
    const PAYMETHOD_3D_BCA_CONFIG_LABEL = 'Credit/Debit Card BCA';
    const PAYMETHOD_3D_BRI_CONFIG_LABEL = 'Credit/Debit Card BRI';
    const PAYMETHOD_3D_DANAMON_CONFIG_LABEL = 'Credit/Debit Card Danamon';
    const PAYMETHOD_3D_MAYBANK_CONFIG_LABEL = 'Credit/Debit Card Maybank';
    const PAYMETHOD_CIMB_IPG_CONFIG_LABEL = 'Credit/Debit Card CIMB IPG';

    const PAYMETHOD_2D_CIMB_CONFIG = 'ipay88_paymethod_2d_cimb';
    const PAYMETHOD_2D_CIMB_IPG_CONFIG = 'ipay88_paymethod_2d_cimb_ipg';
    const PAYMETHOD_2D_BCA_CONFIG = 'ipay88_paymethod_2d_bca';
    const PAYMETHOD_2D_BRI_CONFIG = 'ipay88_paymethod_2d_bri';

    const PAYMETHOD_2D_CIMB_CONFIG_LABEL = 'Credit/Debit Card CIMB 2D';
    const PAYMETHOD_2D_CIMB_IPG_CONFIG_LABEL = 'Credit/Debit Card CIMB IPG 2D';
    const PAYMETHOD_2D_BCA_CONFIG_LABEL = 'Credit/Debit Card BCA 2D';
    const PAYMETHOD_2D_BRI_CONFIG_LABEL = 'Credit/Debit Card BRI 2D';
			
	const PAYMENT_METHOD_CREDITCARD_CONFIG_LABEL		= 'Credit Card (Default)';
	const PAYMENT_METHOD_CREDITCARD_2D_CONFIG_LABEL		= 'Credit Card 2D';
	const PAYMENT_METHOD_MAYBANK2D_CONFIG_LABEL		    = 'Maybank 2D';
	const PAYMENT_METHOD_BRI2D_CONFIG_LABEL		        = 'BRI 2D';
	const PAYMENT_METHOD_ARTAJASAGPN_CONFIG_LABEL		= 'Artajasa GPN';
	const PAYMENT_METHOD_BCAPREAUTH_CONFIG_LABEL		= 'BCA PreAuth Payment';
	const PAYMENT_METHOD_UNIONPAY_CONFIG_LABEL		    = 'UnionPay';
	
	// function
    public function getBanksConfigs() 
	{
        return array(	
            self::PAYMENT_METHOD_CREDITCARD_3D_CONFIG, 
            self::PAYMENT_METHOD_CREDITCARD_2D_CONFIG, 
            self::PAYMENT_METHOD_ARTAJASAGPN_CONFIG,
            self::PAYMENT_METHOD_UNIONPAY_CONFIG     
        );
    }

    public function getFieldsConfigs() 
	{
        return array(	
            self::MERCHANT_CODE,
            self::MERCHANT_KEY,
            self::PAYMENT_MODE,
            self::PAYMENT_METHOD_CREDITCARD_3D_CONFIG, 
            self::PAYMENT_METHOD_CREDITCARD_2D_CONFIG, 
            self::PAYMENT_METHOD_ARTAJASAGPN_CONFIG,
            self::PAYMENT_METHOD_UNIONPAY_CONFIG 
        );
    }

    protected $paymentMethod;
	protected $description;
	protected $banks;
    protected $bankKeyConfig;
    protected $paymentId;
    protected $bankName;
    protected $logo;
    protected $imagePath;
    protected $bankEnabled;
    
	// @return array
    public function getBankEnabled()
    {
        return $this->bankEnabled;
    }

    // @param mixed $bankEnabled
    public function setBankEnabled($bankEnabled)
    {
        $this->bankEnabled = $bankEnabled;
    }

    // @return mixed
    public function getPaymentMethod()
    {
        return $this->paymentMethod;
    }

    // @param mixed $paymentMethod
    public function setPaymentMethod($paymentMethod)
    {
        $this->paymentMethod = $paymentMethod;
    }

    // @return mixed
    public function getBanks()
    {
        return $this->banks;
    }

    // @param mixed $banks
    public function setBanks($banks)
    {
        $this->banks = $banks;
    }

    // @return mixed
    public function getBankKeyConfig()
    {
        return $this->bankKeyConfig;
    }

    // @param mixed $bankKeyConfig
    public function setBankKeyConfig($bankKeyConfig)
    {
        $this->bankKeyConfig = $bankKeyConfig;
    }

    // @return mixed
    public function getPaymentId()
    {
        return $this->paymentId;
    }

    // @param mixed $paymentId
    public function setPaymentId($paymentId)
    {
        $this->paymentId = $paymentId;
    }

    // @return mixed
    public function getBankName()
    {
        return $this->bankName;
    }

    // @param mixed $bankName
    public function setBankName($bankName)
    {
        $this->bankName = $bankName;
    }

	// @return mixed
    public function getLogo()
    {
        return $this->logo;
    }

    // @param mixed $logo
    public function setLogo($logo)
    {
        $this->logo = $logo;
    }

    // @return mixed
    public function getImagePath()
    {
        return $this->imagePath;
    }

    // @param mixed $imagePath
    public function setImagePath($imagePath)
    {
        $this->imagePath = $imagePath;
    }

    // Payment methods, please view technical spec for latest update.
    protected $pMethod = array(
  
		self::PAYMENT_METHOD_CREDITCARD_3D_CONFIG  => 
		array(	
            self::PAYMETHOD_ID_3D_BCA => array (
                'paymentId' => self::PAYMETHOD_ID_3D_BCA,
                'name' 		=> self::PAYMETHOD_3D_BCA_CONFIG_LABEL,
                'logo' 		=> 'Visa-Mastercard-JCB-Amex.png'
            ),
            self::PAYMETHOD_ID_CIMB_IPG => array (
                'paymentId' => self::PAYMETHOD_ID_CIMB_IPG,
                'name' 		=> self::PAYMETHOD_CIMB_IPG_CONFIG_LABEL,
                'logo' 		=> 'Visa-Mastercard-JCB.png'
            ),
            self::PAYMETHOD_ID_3D_CIMB_MPGS => array (
                'paymentId' => self::PAYMETHOD_ID_3D_CIMB_MPGS,
                'name' 		=> self::PAYMETHOD_3D_CIMB_MPGS_CONFIG_LABEL,
                'logo' 		=> 'Visa-Mastercard-JCB.png'
            ),
            self::PAYMETHOD_ID_3D_CIMB_IPG => array (
                'paymentId' => self::PAYMETHOD_ID_3D_CIMB_IPG,
                'name' 		=> self::PAYMETHOD_3D_CIMB_IPG_CONFIG_LABEL,
                'logo' 		=> 'Visa-Mastercard-JCB.png'
            ),
            self::PAYMETHOD_ID_3D_BRI => array (
                'paymentId' => self::PAYMETHOD_ID_3D_BRI,
                'name' 		=> self::PAYMETHOD_3D_BRI_CONFIG_LABEL,
                'logo' 		=> 'Visa-Mastercard-JCB.png'
            ),
            self::PAYMETHOD_ID_3D_DANAMON => array (
                'paymentId' => self::PAYMETHOD_ID_3D_DANAMON,
                'name' 		=> self::PAYMETHOD_3D_DANAMON_CONFIG_LABEL,
                'logo' 		=> 'Visa-Mastercard.png'
            ),
            self::PAYMETHOD_ID_3D_MAYBANK => array (
                'paymentId' => self::PAYMETHOD_ID_3D_MAYBANK,
                'name' 		=> self::PAYMETHOD_3D_MAYBANK_CONFIG_LABEL,
                'logo' 		=> 'Visa-Mastercard.png'
            )
        ),

        self::PAYMENT_METHOD_CREDITCARD_2D_CONFIG  => 
		array(	
            self::PAYMETHOD_ID_2D_BCA => array (
                'paymentId' => self::PAYMETHOD_ID_2D_BCA,
                'name' 		=> self::PAYMETHOD_2D_BCA_CONFIG,
                'logo' 		=> 'Visa-Mastercard-JCB-Amex.png'
            ),
            self::PAYMETHOD_ID_2D_CIMB => array (
                'paymentId' => self::PAYMETHOD_ID_2D_CIMB,
                'name' 		=> self::PAYMETHOD_2D_CIMB_IPG_CONFIG,
                'logo' 		=> 'Visa-Mastercard-JCB.png'
            ),
            self::PAYMETHOD_ID_2D_CIMB_IPG => array (
                'paymentId' => self::PAYMETHOD_ID_2D_CIMB_IPG,
                'name' 		=> self::PAYMETHOD_2D_CIMB_IPG_CONFIG,
                'logo' 		=> 'Visa-Mastercard-JCB.png'
            ),
            self::PAYMETHOD_ID_2D_BRI => array (
                'paymentId' => self::PAYMETHOD_ID_2D_BRI,
                'name' 		=> self::PAYMETHOD_2D_BRI_CONFIG,
                'logo' 		=> 'Visa-Mastercard-JCB.png'
            )
        ),

        self::PAYMENT_METHOD_ARTAJASAGPN_CONFIG  => 
		array(
            self::PAYMENT_METHOD_ARTAJASAGPN => array(
                'paymentId' => self::PAYMENT_METHOD_ARTAJASAGPN,
            	'name' 		=> 'Artajasa GPN',
                'logo' 		=> 'artajasa_gpn.png'
            )
        ),

        self::PAYMENT_METHOD_UNIONPAY_CONFIG  => 
		array(
            self::PAYMENT_METHOD_UNIONPAY => array(
                'paymentId' => self::PAYMENT_METHOD_UNIONPAY,
            	'name' 		=> 'UnionPay',
                'logo' 		=> 'unionpay.png'
            )
        )
    );

    // @return array
    public function getPmethod() 
	{
        return $this->pMethod;
    }

    // @param $key
    // @return null
    public function getPaymentMethodInfoByKey($key) 
	{
        if(isset($this->pMethod[$key])) 
		{
            return $this->pMethod[$key];
        }
        
		return null;
    }

    // @param $id
    // @return null
    public function getPaymentMethodInfoById($key, $id) 
	{
        if(isset($this->pMethod[$key])) 
		{
            return $this->pMethod[$key][$id];
        }
        
		return null;
    }

    public function __construct($options = null)
    {
    }

	//payment checkout
    public function getWiget($banks, $description, $imagePath, $auto = false) 
	{
        $bankConfigurations = $banks;
		
        $html = $description.'<br><br>			
		<p class="form-row">
		<label for="ipay88_payment_type">PaymentType
		<span class="required">*</span></label>
		</p>
		
		<div class="payment_method_ipay88">
		<fieldset>
		<legend>Please choose one to pay</legend>';
				
		if(is_array($bankConfigurations) && count($bankConfigurations)) 
		{
			foreach ($bankConfigurations as $key => $value) 
			{
				if($value) 
				{
					$bank = $this->getPaymentMethodInfoById($key, $value);
					
					if(is_array($bank) && count($bank)) 
					{
						$paymentId	= isset($bank['paymentId']) ? $bank['paymentId'] : '';
						$name 		= isset($bank['name']) ? $bank['name'] : '';
						$logo 		= $imagePath . DIRECTORY_SEPARATOR . (isset($bank['logo']) ? $bank['logo'] : '');

						$html .= '<div><label style="margin-bottom:5px;display:inline-flex;align-items:center;">
						<input type="radio" name="ipay88_bank_payment_method" value="'.$paymentId.'">
						<img class="ipay88_bank_payment_method" src="'.$logo.'" alt="'.$name.'" style="float:none; font-size: 16px; margin-left:1em;"></label></div>';
					}
				}
			}
		}
		
		$html .= '</fieldset></div>';
		
        return $html;
    }
}